/*
**     /\    DayDream BBS
**    //\\   ~~~~~~~~~~~~
**   ///\\\  Copyright 1997 by Mattias Nilsson
**   \\\///  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
**    \\//
**     \/    StartNodes.rexx
**
**	DayDream Node Startup. Starts up DayDream server + nodes.
**  Run this script in your user-startup or so (preferebly last)
**  Ex.
**  "Sys:RexxC/RX DayDream:Rexx/StartNodes.rexx"
**
**
**  Optional argument is Node # to start. If no argument is specified,
**  all nodes configured will be started.
*/

/*----------------------- CHANGE THEESE ! ---------------------------*/

/* Enter the path and name of the DayDream Server here. */
ServerName = "DayDream:Server"

/* Enter the path and name of the DayDream executable here. */
DDName = "DayDream:DayDream"

/* Number of nodes to start. In this example this is 2 */
NumberOfNodes = 2

/* Enter here the node startup options for each node.
** Example shows 2 nodes. 1 regular dial-in node, and 1 local operator node.
*/
nodeargs.2 = "n2 h"			/* Regular DTR drop dial-in node */
nodeargs.3 = "n3 h"		/* Local operator login node */
/* And so on... */


/*-------------------- DON'T CHANGE THEESE BELOW ! ------------------*/
OPTIONS RESULTS
PARSE arg arguments

/* make sure the Server is up and running..
   Timeout is set to 10 seconds.
*/
IF ~show(ports,"DD-Server") THEN do
	address command 'run <>NIL: 'ServerName
	Time(reset)
	do while ~show(ports,"DD-Server")
		IF Time(Elapsed) > 10 THEN do
			SAY "[0mError! [1mCould not start DayDream Server. Please check.[0m"
			Exit 20
		end
	end
end


/* Fire up the nodes. */
node = 1
if arguments = "" THEN
	do while node <= NumberOfNodes;	CALL startnode node; node=node+1; end
else; CALL Startnode arguments

Exit 0



Startnode:
PARSE arg noden
		pname = 'DD_Node_'noden
		IF ~show(ports,pname) THEN do
			address command 'Run <>NIL: 'DDName' 'nodeargs.noden
			Time(reset)
			do while ~show(ports,pname)
				IF Time(Elapsed) > 10 THEN do
					SAY "[0mError! [1mCould not start node "noden". Please check.[0m"; Exit 20; end
			end
		end	
RETURN
